#include "bsp_usart.h"

 /**
  * @brief  ǶжϿNVIC
  * @param  
  * @retval 
  */
static void NVIC_Configuration(void)
{
  NVIC_InitTypeDef NVIC_InitStructure;
  
  /* ǶжϿѡ */
  NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);
  
  /* USARTΪжԴ */
  NVIC_InitStructure.NVIC_IRQChannel = DEBUG_USART_IRQ;
  /* ȼ*/
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
  /* ȼ */
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;
  /* ʹж */
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  /* ʼNVIC */
  NVIC_Init(&NVIC_InitStructure);
}

 /**
  * @brief  USART GPIO ,
  * @param  
  * @retval 
  */
void USART_Config(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;
	USART_InitTypeDef USART_InitStructure;

	// 򿪴GPIOʱ
	DEBUG_USART_GPIO_APBxClkCmd(DEBUG_USART_GPIO_CLK, ENABLE);
	
	// 򿪴ʱ
	DEBUG_USART_APBxClkCmd(DEBUG_USART_CLK, ENABLE);

	// USART TxGPIOΪ츴ģʽ
	GPIO_InitStructure.GPIO_Pin = DEBUG_USART_TX_GPIO_PIN;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(DEBUG_USART_TX_GPIO_PORT, &GPIO_InitStructure);

  // USART RxGPIOΪģʽ
	GPIO_InitStructure.GPIO_Pin = DEBUG_USART_RX_GPIO_PIN;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
	GPIO_Init(DEBUG_USART_RX_GPIO_PORT, &GPIO_InitStructure);
	
	// ôڵĹ
	// ò
	USART_InitStructure.USART_BaudRate = DEBUG_USART_BAUDRATE;
	//  ֳ
	USART_InitStructure.USART_WordLength = USART_WordLength_8b;
	// ֹͣλ
	USART_InitStructure.USART_StopBits = USART_StopBits_1;
	// Уλ
	USART_InitStructure.USART_Parity = USART_Parity_No ;
	// Ӳ
	USART_InitStructure.USART_HardwareFlowControl = 
	USART_HardwareFlowControl_None;
	// ùģʽշһ
	USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
	// ɴڵĳʼ
	USART_Init(DEBUG_USARTx, &USART_InitStructure);
	
	// жȼ
	NVIC_Configuration();
	
	// ʹܴڽж
	USART_ITConfig(DEBUG_USARTx, USART_IT_RXNE, ENABLE);	
	
	// ʹܴ
	USART_Cmd(DEBUG_USARTx, ENABLE);	    
}

/*****************  һֽ **********************/
void Usart_SendByte( USART_TypeDef * pUSARTx, uint8_t ch)
{
	/* һֽݵUSART */
	USART_SendData(pUSARTx,ch);
		
	/* ȴݼĴΪ */
	while (USART_GetFlagStatus(pUSARTx, USART_FLAG_TXE) == RESET);	
}

/****************** 8λ ************************/
void Usart_SendArray( USART_TypeDef * pUSARTx, uint8_t *array, uint16_t num)
{
  uint8_t i;
	
	for(i=0; i<num; i++)
  {
	    /* һֽݵUSART */
	    Usart_SendByte(pUSARTx,array[i]);	
  
  }
	/* ȴ */
	while(USART_GetFlagStatus(pUSARTx,USART_FLAG_TC)==RESET);
}

/*****************  ַ **********************/
void Usart_SendString( USART_TypeDef * pUSARTx, char *str)
{
	unsigned int k=0;
  do 
  {
      Usart_SendByte( pUSARTx, *(str + k) );
      k++;
  } while(*(str + k)!='\0');
  
  /* ȴ */
  while(USART_GetFlagStatus(pUSARTx,USART_FLAG_TC)==RESET)
  {}
}

/*****************  һ16λ **********************/
void Usart_SendHalfWord( USART_TypeDef * pUSARTx, uint16_t ch)
{
	uint8_t temp_h, temp_l;
	
	/* ȡ߰λ */
	temp_h = (ch&0XFF00)>>8;
	/* ȡͰλ */
	temp_l = ch&0XFF;
	
	/* ͸߰λ */
	USART_SendData(pUSARTx,temp_h);	
	while (USART_GetFlagStatus(pUSARTx, USART_FLAG_TXE) == RESET);
	
	/* ͵Ͱλ */
	USART_SendData(pUSARTx,temp_l);	
	while (USART_GetFlagStatus(pUSARTx, USART_FLAG_TXE) == RESET);	
}

///ضc⺯printfڣضʹprintf
int fputc(int ch, FILE *f)
{
		/* һֽݵ */
		USART_SendData(DEBUG_USARTx, (uint8_t) ch);
		
		/* ȴ */
		while (USART_GetFlagStatus(DEBUG_USARTx, USART_FLAG_TXE) == RESET);		
	
		return (ch);
}

///ضc⺯scanfڣдʹscanfgetcharȺ
int fgetc(FILE *f)
{
		/* ȴ */
		while (USART_GetFlagStatus(DEBUG_USARTx, USART_FLAG_RXNE) == RESET);

		return (int)USART_ReceiveData(DEBUG_USARTx);
}

